/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/ts/bundles/configExports.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/ts/AssetInteractionUI.ts":
/*!**************************************!*\
  !*** ./src/ts/AssetInteractionUI.ts ***!
  \**************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var ConfigPanelUI_1 = __webpack_require__(/*! ./ConfigPanelUI */ "./src/ts/ConfigPanelUI.ts");
var AssetInteractionUI = (function (_super) {
    __extends(AssetInteractionUI, _super);
    function AssetInteractionUI(settings) {
        var _this = _super.call(this, settings, "asset-interaction-panel") || this;
        _this.MediaClickInteraction = "clickInteraction";
        return _this;
    }
    AssetInteractionUI.prototype.init = function () {
        var self = this;
        this.$clickInteractionDoNothingRadioButton = $("#clickInteractionDoNothing");
        this.$clickInteractionLinkRadioButton = $("#clickInteractionLink");
        this.$clickInteractionLinkInputDiv = $("#clickInteractionLinkInputDiv");
        this.$clickInteractionCustomLinkRadioButton = $("#clickInteractionCustomUrl");
        this.$clickInteractionCustomLinkInputDiv = $("#clickInteractionCustomUrlInputDiv");
        this.$customUrlInput = this.getInput("clickInteractionCustomUrlData");
        this.setValue("clickInteraction", this.settings.instanceConfig.click.mode);
        this.setValue(this.$customUrlInput, this.settings.instanceConfig.click.customUrl);
        this.$clickInteractionLinkRadioButton.change(function () { self.updateUiToReflectClickInteractionRadio(); });
        this.$clickInteractionDoNothingRadioButton.change(function () { self.updateUiToReflectClickInteractionRadio(); });
        this.$clickInteractionCustomLinkRadioButton.change(function () { self.updateUiToReflectClickInteractionRadio(); });
        this.$customUrlInput.blur(function () {
            self.validateCustomUrl();
        });
        this.updateUiToReflectClickInteractionRadio();
    };
    AssetInteractionUI.prototype.validateCustomUrl = function () {
        var customUrl = this.getValue(this.$customUrlInput);
        var url = this.fixUrl(customUrl);
        if (url !== customUrl)
            this.setValue(this.$customUrlInput, url);
    };
    AssetInteractionUI.prototype.fixUrl = function (url) {
        if (!url)
            return "";
        url = url.trim();
        return url;
    };
    AssetInteractionUI.prototype.setEnabled = function (enabled) {
        if (enabled) {
            if (this.lastClickInteraction) {
                this.setValue(this.MediaClickInteraction, this.lastClickInteraction);
            }
        }
        else {
            this.lastClickInteraction = this.getValue(this.MediaClickInteraction);
            this.setValue(this.MediaClickInteraction, "none");
        }
        _super.prototype.setEnabled.call(this, enabled);
    };
    AssetInteractionUI.prototype.updateUiToReflectClickInteractionRadio = function () {
        this.$clickInteractionLinkInputDiv.hide();
        this.$clickInteractionCustomLinkInputDiv.hide();
        switch (this.getValue("clickInteraction")) {
            case "link":
                this.$clickInteractionLinkInputDiv.show();
                break;
            case "custom":
                this.$clickInteractionCustomLinkInputDiv.show();
                break;
        }
    };
    AssetInteractionUI.prototype.getClickInteractionData = function () {
        var url = null;
        var mode = this.getValue(this.MediaClickInteraction);
        var customUrl = this.getValue(this.$customUrlInput);
        switch (mode) {
            case "custom":
                url = customUrl;
                break;
            default:
                url = null;
                break;
        }
        return {
            mode: mode,
            customUrl: customUrl,
            url: url
        };
    };
    return AssetInteractionUI;
}(ConfigPanelUI_1.ConfigPanelUI));
exports.AssetInteractionUI = AssetInteractionUI;


/***/ }),

/***/ "./src/ts/CategoryFilterUI.ts":
/*!************************************!*\
  !*** ./src/ts/CategoryFilterUI.ts ***!
  \************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ConfigUI_1 = __webpack_require__(/*! ./ConfigUI */ "./src/ts/ConfigUI.ts");
var CategoryFilterUI = (function (_super) {
    __extends(CategoryFilterUI, _super);
    function CategoryFilterUI(settings, categoriesChanged) {
        var _this = _super.call(this, settings) || this;
        _this.categoriesChanged = categoriesChanged;
        return _this;
    }
    CategoryFilterUI.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var self;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        self = this;
                        this.$categorySelect = $("select[name=categoryId]");
                        this.$categoryUl = $(".category-row ul");
                        return [4, this.reloadTopLevelCategories()];
                    case 1:
                        _a.sent();
                        this.$categorySelect.change(function () { return __awaiter(_this, void 0, void 0, function () {
                            var selectedCategory, categoryId;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        selectedCategory = self.$categorySelect.val();
                                        if (!selectedCategory) return [3, 2];
                                        categoryId = parseInt(selectedCategory.toString());
                                        return [4, this.addTopLevelCategory(categoryId)];
                                    case 1:
                                        _a.sent();
                                        self.$categoryUl.show();
                                        self.$categorySelect.children().filter("[value=" + categoryId + "]").remove();
                                        self.$categorySelect.val("0");
                                        _a.label = 2;
                                    case 2: return [2];
                                }
                            });
                        }); });
                        return [2];
                }
            });
        });
    };
    CategoryFilterUI.prototype.getCategoryComponentHeight = function () {
        var $selectedCategories = $(".category-selected");
        if ($selectedCategories.length == 0)
            return 0;
        return this.$categoryUl.outerHeight(true);
    };
    CategoryFilterUI.prototype.getSelectedCategories = function () {
        var r = [];
        var $selectedCategories = $(".category-selected");
        if ($selectedCategories && $selectedCategories.length) {
            for (var i = 0; i < $selectedCategories.length; i++) {
                var id = parseInt($($selectedCategories[i]).data("id"));
                if (id && !r.includes(id))
                    r.push(id);
            }
        }
        return r;
    };
    CategoryFilterUI.prototype.addOption = function (text, id) {
        var $o = $("<option></option>");
        $o.text(text);
        $o.val(id);
        this.$categorySelect.append($o);
    };
    CategoryFilterUI.prototype.reloadTopLevelCategories = function () {
        return __awaiter(this, void 0, void 0, function () {
            var self, sel;
            return __generator(this, function (_a) {
                self = this;
                sel = this.getSelectedCategories();
                if (!sel || !sel.length) {
                    this.$categoryUl.hide();
                }
                this.settings.dataStore.getAllCategories().then(function (categories) {
                    self.$categorySelect.empty();
                    self.addOption(self.i18n("select-category"), 0);
                    if (!categories || !categories.length)
                        return;
                    categories.forEach(function (ca) {
                        if (sel.includes(ca.Id))
                            return;
                        self.addOption(ca.Name, ca.Id);
                    });
                });
                return [2];
            });
        });
    };
    CategoryFilterUI.prototype.appendCategoryLi = function ($ul, cat) {
        var _this = this;
        var self = this;
        var children = "";
        if (cat.Categories && cat.Categories.length) {
            cat.Categories.map(function (c) {
                children += "<a class='category-child category-name' data-id='" + c.Id + "' href='#'>" + ImageVault.Util.htmlEncode(c.Name) + "</a>";
            });
        }
        var $li = $("<li data-id='" + cat.Id + "'><span class='parent-category'><a class='remove-category' href='#'>x</a><span class='category-name category-selected' data-id='" + cat.Id + "'>" + ImageVault.Util.htmlEncode(cat.Name) + "</span>&gt;</span>" + children + "<ul></ul></li>");
        $ul.append($li);
        $("a.remove-category", $li).click(function (e) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2, self.removeCategory(e)];
        }); }); });
        $("a.category-name", $li).click(function (e) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2, self.toggleCategory(e)];
        }); }); });
    };
    CategoryFilterUI.prototype.removeCategory = function (e) {
        return __awaiter(this, void 0, void 0, function () {
            var $a, $li, id, $gp, isChild;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        e.preventDefault();
                        $a = $(e.currentTarget);
                        $li = $a.closest("li");
                        id = $li.data("id");
                        $("a[data-id=" + id + "]").removeClass("category-selected");
                        $gp = $li.parent().parent();
                        isChild = ($gp.is("li"));
                        $li.remove();
                        if (!!isChild) return [3, 2];
                        return [4, this.reloadTopLevelCategories()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        this.notifyCategoriesChanged();
                        return [2, false];
                }
            });
        });
    };
    CategoryFilterUI.prototype.notifyCategoriesChanged = function () {
        this.categoriesChanged();
    };
    CategoryFilterUI.prototype.toggleCategory = function (e) {
        return __awaiter(this, void 0, void 0, function () {
            var self, $a, isSelected, id, $parentLi, category, $ul;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        self = this;
                        e.preventDefault();
                        $a = $(e.currentTarget);
                        isSelected = $a.hasClass("category-selected");
                        $a.toggleClass("category-selected");
                        id = $a.data("id");
                        $parentLi = $a.closest("li");
                        if (!isSelected) return [3, 1];
                        $("li[data-id=" + id + "]", $parentLi).remove();
                        return [3, 3];
                    case 1: return [4, self.settings.dataStore.getCategoryById(id)];
                    case 2:
                        category = _a.sent();
                        if (category.Categories && category.Categories.length) {
                            $ul = $("ul", $parentLi).first();
                            self.appendCategoryLi($ul, category);
                        }
                        _a.label = 3;
                    case 3:
                        this.notifyCategoriesChanged();
                        return [2, false];
                }
            });
        });
    };
    CategoryFilterUI.prototype.addTopLevelCategory = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var cat;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.settings.dataStore.getCategoryById(id)];
                    case 1:
                        cat = _a.sent();
                        this.logResult("INFO", "Adding category " + cat.Name);
                        this.appendCategoryLi(this.$categoryUl, cat);
                        this.notifyCategoriesChanged();
                        return [2];
                }
            });
        });
    };
    return CategoryFilterUI;
}(ConfigUI_1.ConfigUI));
exports.CategoryFilterUI = CategoryFilterUI;


/***/ }),

/***/ "./src/ts/ConfigLoaderUI.ts":
/*!**********************************!*\
  !*** ./src/ts/ConfigLoaderUI.ts ***!
  \**********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var GlobalConfigUI_1 = __webpack_require__(/*! ./GlobalConfigUI */ "./src/ts/GlobalConfigUI.ts");
var InstanceConfigUI_1 = __webpack_require__(/*! ./InstanceConfigUI */ "./src/ts/InstanceConfigUI.ts");
var ConfigUI_1 = __webpack_require__(/*! ./ConfigUI */ "./src/ts/ConfigUI.ts");
var ConfigLoaderUI = (function (_super) {
    __extends(ConfigLoaderUI, _super);
    function ConfigLoaderUI() {
        return _super.call(this, null) || this;
    }
    ConfigLoaderUI.prototype.init = function (values) {
        var self = this;
        console.log("init");
        window.requester.doGet({ route: '/settings' })
            .done(function (settings) {
            settings.config = settings.config || {};
            self.settings = settings;
            if ($("html").hasClass("webapp-config")) {
                self.childConfigUI = new GlobalConfigUI_1.GlobalConfigUI(settings);
            }
            else {
                if (!settings.config.ivUrl) {
                    self.alert(self.i18n("configuration-is-not-completed", settings.appInfo.addon.displayName), "warning");
                    self.hideLoader();
                    return;
                }
                self.childConfigUI = new InstanceConfigUI_1.InstanceConfigUI(settings);
            }
            self.childConfigUI.init(values);
        }).fail(function (response) {
            self.error(response);
        });
    };
    return ConfigLoaderUI;
}(ConfigUI_1.ConfigUI));
exports.ConfigLoaderUI = ConfigLoaderUI;


/***/ }),

/***/ "./src/ts/ConfigPanelUI.ts":
/*!*********************************!*\
  !*** ./src/ts/ConfigPanelUI.ts ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var ConfigUI_1 = __webpack_require__(/*! ./ConfigUI */ "./src/ts/ConfigUI.ts");
var ConfigPanelUI = (function (_super) {
    __extends(ConfigPanelUI, _super);
    function ConfigPanelUI(settings, id) {
        var _this = _super.call(this, settings) || this;
        _this.$panel = $("#" + id);
        return _this;
    }
    ConfigPanelUI.prototype.init = function () {
    };
    ConfigPanelUI.prototype.setEnabled = function (enabled) {
        if (enabled) {
            this.$panel.show();
        }
        else {
            this.$panel.hide();
        }
    };
    return ConfigPanelUI;
}(ConfigUI_1.ConfigUI));
exports.ConfigPanelUI = ConfigPanelUI;


/***/ }),

/***/ "./src/ts/ConfigUI.ts":
/*!****************************!*\
  !*** ./src/ts/ConfigUI.ts ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var ConfigUI = (function () {
    function ConfigUI(settings) {
        this.settings = settings;
        this.$activationPanel = $("#activation-panel");
        this.$activationMessage = $("#activation-message", this.$activationPanel);
        this.$activationSpinner = $(".spinner", this.$activationPanel);
    }
    ConfigUI.prototype.hideLoader = function () {
        $("#loader").hide();
    };
    ConfigUI.prototype.showLoader = function () {
        $("#loader").show();
    };
    ConfigUI.prototype.logResult = function (type, message) {
        var msg = type + "\t" + this.toString(message);
        console.log(msg);
    };
    ConfigUI.prototype.hideAlert = function () {
        $("#alert").removeClass("alert-success").removeClass("alert-danger").removeClass("alert-warning").removeClass("alert-info").hide();
    };
    ConfigUI.prototype.i18n = function (key) {
        var _a;
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (!ImageVault.Util.has(this.settings.i18n, key))
            return "[i18n missing for '" + key + "']";
        var val = this.settings.i18n[key].toString();
        val = (_a = ImageVault.Util).formatString.apply(_a, [val].concat(args));
        return val;
    };
    ConfigUI.prototype.showActivationMessage = function (message) {
        this.$activationSpinner.show();
        this.$activationMessage.removeClass("alert-danger");
        this.$activationMessage.addClass("alert-info");
        this.$activationMessage.html(message);
        this.$activationPanel.show();
    };
    ConfigUI.prototype.showActivationError = function (message) {
        this.$activationSpinner.hide();
        this.$activationMessage.removeClass("alert-info");
        this.$activationMessage.addClass("alert-danger");
        this.$activationMessage.html(message);
        this.$activationPanel.show();
    };
    ConfigUI.prototype.hideActivationMessage = function () {
        this.$activationPanel.hide();
    };
    ConfigUI.prototype.alert = function (message, type) {
        this.hideAlert();
        if (!type)
            type = "danger";
        $("#alert").addClass("alert-" + type).html(message).show();
    };
    ConfigUI.prototype.toString = function (arg) {
        if (!arg)
            return "";
        if (typeof arg === "string")
            return arg;
        var e = arg;
        if (e.error) {
            return this.toString(e.error);
        }
        var m = arg;
        if (m.message)
            return m.message;
        return "";
    };
    ConfigUI.prototype.error = function (arg1, arg2) {
        var msg = this.toString(arg1);
        var suffix = this.toString(arg2);
        if (suffix) {
            msg = msg + " " + suffix;
        }
        this.logResult("ERROR", msg);
        this.alert(msg);
    };
    ConfigUI.prototype.getInput = function (key) {
        var $input;
        $input = $('input[name=' + key + ']');
        if ($input.length === 0)
            $input = $('select[name=' + key + ']');
        if ($input.length === 0)
            throw this.i18n("e-001-no-input-named-x-found", key);
        return $input;
    };
    ConfigUI.prototype.setValue = function (key, value) {
        if (value && typeof value === "object") {
            value = JSON.stringify(value);
        }
        var $input;
        if (typeof key === "string") {
            $input = this.getInput(key);
        }
        else {
            $input = key;
        }
        if ($input.length > 1) {
            $input.prop("checked", false);
            $input.filter("[value='" + value + "']").prop("checked", true);
        }
        else {
            if ($input.is("[type=checkbox]")) {
                $input.prop("checked", !!value);
            }
            else {
                $input.val(value);
            }
        }
    };
    ConfigUI.prototype.getValue = function (key) {
        var $input;
        if (typeof key === "string") {
            $input = this.getInput(key);
        }
        else {
            $input = key;
        }
        if ($input && $input.length > 1) {
            $input = $input.filter(":checked");
        }
        if (!$input || !$input.length)
            return null;
        var v = $input.val();
        if (v == null)
            return null;
        return v.toString();
    };
    ConfigUI.prototype.getIntValue = function (key) {
        var v = this.getValue(key);
        if (v == null || v.length === 0)
            return null;
        return parseInt(v);
    };
    ConfigUI.prototype.getBooleanValue = function (key) {
        var $i = key;
        if ((typeof key) === "string") {
            $i = this.getInput(key);
        }
        if (!$i)
            throw "Cannot find input named " + key;
        if ($i.attr("type").toLowerCase() !== "checkbox") {
            throw "Cannot get boolean value from a non checkbox input";
        }
        return $i.is(":checked");
    };
    ConfigUI.prototype.getMedia = function (parameters) {
        var self = this;
        return new Promise(function (resolve, reject) {
            ImageVault.MediaService.Find(self.settings.client, parameters).then(function (mediaItems) {
                if (!mediaItems || !mediaItems.length) {
                    reject("ImageVault did not get a hit on the requested media");
                    return;
                }
                var mediaItem = mediaItems[0];
                var conversions = mediaItem.MediaConversions;
                if (!conversions || !conversions.length) {
                    reject("ImageVault did not get a conversion on the media item with id " + mediaItem.Id);
                    return;
                }
                var media = conversions[0];
                resolve(media);
            }).catch(reject);
        });
    };
    ConfigUI.ClientIdentityAuth = "Basic c2l0ZXZpc2lvbjo1V0IzZUsldlpqVWU=";
    return ConfigUI;
}());
exports.ConfigUI = ConfigUI;


/***/ }),

/***/ "./src/ts/DataStore.ts":
/*!*****************************!*\
  !*** ./src/ts/DataStore.ts ***!
  \*****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var DataStore = (function () {
    function DataStore(client) {
        this.client = client;
        var self = this;
        this.allMetadataDefinitions = new Promise(function (resolve) {
            ImageVault.MetadataDefinitionService.Find(self.client, {}).then(function (mds) {
                mds.sort(function (m1, m2) {
                    var typeDiff = m1.MetadataDefinitionType - m2.MetadataDefinitionType;
                    if (typeDiff)
                        return typeDiff;
                    return m1.Name > m2.Name ? 1 : m1.Name < m2.Name ? -1 : 0;
                });
                resolve(mds);
            });
        });
        this.allVaults = ImageVault.VaultService.Find(self.client, {});
        this.allCategories = ImageVault.CategoryService.getCategories(self.client);
        this.categoryIndex = this.allCategories.then(function (list) {
            var d = {};
            var cs = [];
            cs = cs.concat(list);
            while (cs.length) {
                var c = cs[0];
                cs = cs.slice(1);
                d[c.Id] = c;
                if (c.Categories && c.Categories.length) {
                    cs = cs.concat(c.Categories);
                }
            }
            return d;
        });
        this.version = new Promise(function (resolve, reject) {
            self.client.get("info/version", function (info) {
                resolve(info.version);
            }, function (reason) { reject(reason); });
        });
    }
    DataStore.prototype.getAllMetadataDefinitions = function () {
        return this.allMetadataDefinitions;
    };
    DataStore.prototype.getVersion = function () {
        return this.version;
    };
    DataStore.prototype.getAllCategories = function () {
        return this.allCategories;
    };
    DataStore.prototype.getCategoryById = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var d;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.categoryIndex];
                    case 1:
                        d = _a.sent();
                        return [2, d[id]];
                }
            });
        });
    };
    DataStore.prototype.getVault = function (id) {
        var self = this;
        if (!id)
            return null;
        return new Promise(function (resolve) {
            self.allVaults.then(function (vaults) {
                var matchingVaults = vaults.filter(function (v) { return v.Id === id; });
                if (!matchingVaults || matchingVaults.length !== 1)
                    resolve(null);
                resolve(matchingVaults[0]);
            });
        });
    };
    DataStore.prototype.getMetadataDefinitionByTypeAndName = function (definitionType, name) {
        var self = this;
        return new Promise(function (resolve) {
            self.allMetadataDefinitions.then(function (definitions) {
                var matchingDefinitions = definitions.filter(function (md) { return md.MetadataDefinitionType === definitionType && md.Name === name; });
                if (!matchingDefinitions || matchingDefinitions.length !== 1)
                    resolve(null);
                resolve(matchingDefinitions[0]);
            });
        });
    };
    DataStore.prototype.getMetadataDefinition = function (id) {
        var self = this;
        if (!id)
            return null;
        return new Promise(function (resolve) {
            self.allMetadataDefinitions.then(function (definitions) {
                var matchingDefinitions = definitions.filter(function (md) { return md.Id === id; });
                if (!matchingDefinitions || matchingDefinitions.length !== 1)
                    resolve(null);
                resolve(matchingDefinitions[0]);
            });
        });
    };
    DataStore.prototype.formatAssetMetadata = function (metadata) {
        var _this = this;
        return new Promise(function (resolve) {
            _this.getMetadataDefinition(metadata.definitionId).then(function (md) {
                var value = metadata.value;
                switch (md.MetadataType) {
                    case ImageVault.MetadataType.Boolean:
                        value = metadata.booleanValue ? "true" : "false";
                        break;
                    case ImageVault.MetadataType.DateTime:
                        value = new Date(metadata.dateValue).toLocaleString();
                        break;
                }
                resolve({ metadataDefinition: md, formattedValue: value });
            });
        });
    };
    return DataStore;
}());
exports.DataStore = DataStore;


/***/ }),

/***/ "./src/ts/GlobalConfigUI.ts":
/*!**********************************!*\
  !*** ./src/ts/GlobalConfigUI.ts ***!
  \**********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var $ = __webpack_require__(/*! jquery */ "jquery");
var VersionUtil_1 = __webpack_require__(/*! ./VersionUtil */ "./src/ts/VersionUtil.ts");
var ConfigUI_1 = __webpack_require__(/*! ./ConfigUI */ "./src/ts/ConfigUI.ts");
var GlobalConfigUI = (function (_super) {
    __extends(GlobalConfigUI, _super);
    function GlobalConfigUI(settings) {
        return _super.call(this, settings) || this;
    }
    GlobalConfigUI.prototype.init = function () {
        var _this = this;
        var self = this;
        this.$currentUserStatus = $("#current-user-status");
        this.$logoutButton = $("#logout-user-button");
        this.$imageVaultUrlTextBox = this.getInput(GlobalConfigUI.ImageVaultUrlKey);
        this.$requireAltTextCheckbox = this.getInput("alt-text-required");
        this.setValue(this.$imageVaultUrlTextBox, this.settings.config.ivUrl);
        this.setValue(this.$requireAltTextCheckbox, this.settings.config.requireAltText || false);
        this.updateCurrentUserSettings();
        this.$imageVaultUrlTextBox.blur(function () {
            self.showLoader();
            self.hideAlert();
            setTimeout(function () {
                try {
                    var res = self.verifyImageVaultUrlSync();
                    if (!res.success) {
                        self.alert(res.message);
                    }
                    else {
                        self.updateCurrentUserSettings();
                    }
                }
                finally {
                    self.hideLoader();
                }
            }, 100);
        });
        $("#clear-settings-button").click(function (e) {
            e.preventDefault();
            self.showLoader();
            self.resetAppConfig();
            self.hideLoader();
            return false;
        });
        this.$logoutButton.click(function (e) {
            e.preventDefault();
            var client = _this.createClient();
            if (client) {
                client.removeCachedCredentials();
                _this.updateCurrentUserSettings();
            }
            return false;
        });
        window.validate = function () {
            try {
                self.showLoader();
                var res = self.verifyImageVaultUrlSync();
                if (!res.success) {
                    self.alert(res.message);
                    return false;
                }
                if (!self.verifyClientAuthentication()) {
                    self.alert(self.i18n("license-not-active-at-x", self.getValue(GlobalConfigUI.ImageVaultUrlKey)));
                    return false;
                }
                return true;
            }
            finally {
                self.hideLoader();
            }
        };
        window.getValues = function () {
            var url = _this.getValue(_this.$imageVaultUrlTextBox);
            var requireAltText = _this.getBooleanValue(_this.$requireAltTextCheckbox);
            window.requester.doPost({ route: '/config', data: { ivUrl: url, requireAltText: requireAltText }, async: false })
                .done(function (response) { self.logResult("info", self.i18n("done") + ":" + JSON.stringify(response)); })
                .fail(function (response) { self.logResult("error", "fail: " + JSON.stringify(response)); });
            return {};
        };
        $("#global-settings").show();
        this.hideLoader();
    };
    GlobalConfigUI.prototype.createClient = function () {
        try {
            var url = this.getValue(GlobalConfigUI.ImageVaultUrlKey);
            if (!url)
                return null;
            return new ImageVault.PinClient({ ivUrl: url, activationCallback: function () { }, clientIdentityAuth: ConfigUI_1.ConfigUI.ClientIdentityAuth });
        }
        catch (e) {
            this.logResult("ERROR", e);
            return null;
        }
    };
    GlobalConfigUI.prototype.resetAppConfig = function () {
        window.requester.doDelete({ route: '/config', async: false });
    };
    GlobalConfigUI.prototype.updateCurrentUserSettings = function () {
        var pinClient = this.createClient();
        if (pinClient && pinClient.hasCachedCredentials()) {
            this.$logoutButton.removeAttr("disabled");
            this.$currentUserStatus.text(this.i18n("cached-credentials-exists"));
        }
        else {
            this.$logoutButton.attr("disabled", "disabled");
            this.$currentUserStatus.text(this.i18n("no-cached-credentials-exists"));
        }
    };
    GlobalConfigUI.prototype.verifyClientAuthentication = function () {
        var self = this;
        var pinClient = this.createClient();
        if (!pinClient)
            return false;
        var success = false;
        pinClient.pinCodeRequest(false, function (pinCodeResponse) {
            success = !!(pinCodeResponse.pin);
            self.logResult("INFO", "Pin code request succeeded(" + success + "): " + pinCodeResponse.pin);
        }, function (error) {
            self.logResult("ERROR", error);
            success = false;
        });
        return success;
    };
    GlobalConfigUI.prototype.verifyImageVaultUrlSync = function () {
        var self = this;
        var url = this.getValue(GlobalConfigUI.ImageVaultUrlKey);
        var res = { success: false, message: this.i18n("you-must-supply-the-url-to-the-imagevault-service") };
        if (!url)
            return res;
        url = url.toLocaleLowerCase();
        if (!url.endsWith('/')) {
            url = url + "/";
        }
        this.setValue(GlobalConfigUI.ImageVaultUrlKey, url);
        $.ajax({
            async: false,
            method: 'GET',
            url: url + "/apiv2/info/version",
            dataType: 'json',
            success: function (info) {
                if (!info || !info.version) {
                    res.message = self.i18n("unsupported-imagevault-service-located-at", url);
                    return;
                }
                if (VersionUtil_1.VersionUtil.verifyMinVersion(info.version, GlobalConfigUI.imageVaultMinVersion)) {
                    res.message = self.i18n("imagevault-service-verified-version", info.version);
                    res.success = true;
                    return;
                }
                res.message = self.i18n("imagevault-service-does-not-meet-required-version", GlobalConfigUI.imageVaultMinVersion, url, info.version);
                return;
            },
            error: function (jqXHR, status, e) {
                var msg = e;
                if (jqXHR.responseJSON) {
                    msg = jqXHR.responseJSON.ExceptionMessage || jqXHR.responseJSON.Message || msg;
                }
                res.message = self.i18n("failed-to-connect-to-imagevault-service", url);
                console.log(msg);
            }
        });
        return res;
    };
    GlobalConfigUI.imageVaultMinVersion = "5.9";
    GlobalConfigUI.ImageVaultUrlKey = "imageVaultUrl";
    return GlobalConfigUI;
}(ConfigUI_1.ConfigUI));
exports.GlobalConfigUI = GlobalConfigUI;
var VerifyVersionResult = (function () {
    function VerifyVersionResult() {
    }
    return VerifyVersionResult;
}());


/***/ }),

/***/ "./src/ts/InfoPanelUI.ts":
/*!*******************************!*\
  !*** ./src/ts/InfoPanelUI.ts ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ConfigUI_1 = __webpack_require__(/*! ./ConfigUI */ "./src/ts/ConfigUI.ts");
var MetadataTextUI_1 = __webpack_require__(/*! ./MetadataTextUI */ "./src/ts/MetadataTextUI.ts");
var ConfigPanelUI_1 = __webpack_require__(/*! ./ConfigPanelUI */ "./src/ts/ConfigPanelUI.ts");
var ThumbSelectorUI_1 = __webpack_require__(/*! ./ThumbSelectorUI */ "./src/ts/ThumbSelectorUI.ts");
var InfoPanelUI = (function (_super) {
    __extends(InfoPanelUI, _super);
    function InfoPanelUI(broker) {
        var _this = _super.call(this, broker.settings) || this;
        _this.broker = broker;
        return _this;
    }
    InfoPanelUI.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var self, _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        self = this;
                        this.$editButton = $("#edit-asset-button");
                        this.$removeButton = $("#remove-asset-button");
                        this.$assetInfoList = $("#asset-info-list");
                        this.$mediaSettingsDocumentRow = $("#media-settings-document");
                        this.$mediaSettingsMediaRow = $("#media-settings-media");
                        _a = this;
                        return [4, this.settings.dataStore.getMetadataDefinitionByTypeAndName(ImageVault.MetadataDefinitionType.System, "ImageWidth")];
                    case 1:
                        _a.widthSystemMetadata = _b.sent();
                        if (!this.widthSystemMetadata) {
                            this.logResult("ERROR", "Cannot find System ImageWidth metadata definition");
                        }
                        if (!this.settings.instanceConfig.puff) {
                            this.settings.instanceConfig.puff = { formatId: -1 };
                        }
                        this.puffFormatSelector = new ThumbSelectorUI_1.ThumbSelectorUI(this.broker, { prefix: "puff", targetSize: 200, data: this.settings.instanceConfig.puff });
                        this.assetFormatSelector = new ThumbSelectorUI_1.ThumbSelectorUI(this.broker, {
                            prefix: "asset", targetSize: 800, data: this.settings.instanceConfig, thumbEdited: function () {
                                self.puffFormatSelector.updateThumbnail();
                            }
                        });
                        this.puffFormatSelector.init();
                        this.assetFormatSelector.init();
                        this.altTextUI = new MetadataTextUI_1.MetadataTextUI(this.settings, "alt-text", this.settings.instanceConfig.altTextData, this.settings.config.requireAltText);
                        this.altTextUI.init();
                        this.captionUI = new MetadataTextUI_1.MetadataTextUI(this.settings, "caption", this.settings.instanceConfig.captionData, false);
                        this.captionUI.init();
                        this.assetOptimizationPanelUI = new ConfigPanelUI_1.ConfigPanelUI(this.settings, "asset-optimization-panel");
                        this.assetOptimizationPanelUI.init();
                        this.$editButton.click(function (e) {
                            e.preventDefault();
                            $(this).blur();
                            self.assetFormatSelector.editAsset();
                            return false;
                        });
                        this.$removeButton.click(function (e) {
                            e.preventDefault();
                            $(_this).blur();
                            self.selectAsset(null);
                            return false;
                        });
                        return [4, this.assetFormatSelector.updateFormats()];
                    case 2:
                        _b.sent();
                        return [4, this.puffFormatSelector.updateFormats()];
                    case 3:
                        _b.sent();
                        return [4, this.updateSelectedInfoById()];
                    case 4:
                        _b.sent();
                        return [2];
                }
            });
        });
    };
    InfoPanelUI.prototype.updateSelectedInfoById = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var self, r, asset, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        self = this;
                        if (!id) {
                            id = this.settings.instanceConfig.id;
                        }
                        if (!id) {
                            return [2];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 6]);
                        return [4, this.broker.mediaServiceUtil.getAsset(id)];
                    case 2:
                        r = _a.sent();
                        if (!r.value || r.value.length === 0) {
                            throw self.i18n("cannot-find-asset-with-id-x", id);
                        }
                        asset = r.value[0];
                        return [4, self.updateSelectedInfo(asset)];
                    case 3:
                        _a.sent();
                        return [3, 6];
                    case 4:
                        e_1 = _a.sent();
                        return [4, self.updateSelectedInfo(null)];
                    case 5:
                        _a.sent();
                        self.assetFormatSelector.showThumbnailLoaderErrorMessage(e_1);
                        return [3, 6];
                    case 6: return [2];
                }
            });
        });
    };
    InfoPanelUI.prototype.selectAsset = function (asset) {
        return __awaiter(this, void 0, void 0, function () {
            var id;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.settings.instanceConfig.effects = null;
                        id = 0;
                        if (asset) {
                            id = parseInt(asset.id);
                        }
                        ;
                        this.settings.instanceConfig.id = id;
                        return [4, this.updateSelectedInfo(asset)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    InfoPanelUI.prototype.isCurrentAssetEditable = function () {
        return this.isCurrentAssetVideo() || this.isCurrentAssetImage();
    };
    InfoPanelUI.prototype.isCurrentAssetImage = function () {
        if (!this.currentAsset)
            return false;
        var contentType = this.currentAsset.contentType;
        if (!contentType)
            return false;
        contentType = contentType.toLocaleLowerCase();
        if (contentType.startsWith("image"))
            return true;
        if (contentType == "application/pdf")
            return true;
        if (contentType == "application/postscript")
            return true;
        return false;
    };
    InfoPanelUI.prototype.isCurrentAssetVideo = function () {
        if (!this.currentAsset)
            return false;
        var contentType = this.currentAsset.contentType;
        if (!contentType)
            return false;
        contentType = contentType.toLocaleLowerCase();
        if (contentType.startsWith("video"))
            return true;
        return false;
    };
    InfoPanelUI.prototype.getCurrentAssetWidth = function () {
        var self = this;
        if (!this.widthSystemMetadata) {
            return null;
        }
        if (!this.currentAsset || !this.currentAsset.metadata)
            return null;
        var matchingMetadata = this.currentAsset.metadata.filter(function (m) {
            return m.definitionId === self.widthSystemMetadata.Id;
        });
        if (!matchingMetadata || !matchingMetadata.length)
            return null;
        return matchingMetadata[0].integerValue;
    };
    InfoPanelUI.prototype.enableFormatSelection = function (enable) {
        if (enable === void 0) { enable = true; }
        this.assetFormatSelector.enable(enable);
        if (enable) {
            this.$mediaSettingsDocumentRow.hide();
            this.$mediaSettingsMediaRow.show();
        }
        else {
            this.$mediaSettingsMediaRow.hide();
            this.$mediaSettingsDocumentRow.show();
        }
    };
    InfoPanelUI.prototype.updateSelectedInfo = function (asset) {
        return __awaiter(this, void 0, void 0, function () {
            var self, assetEditable, assetImage, v, date, categories, metadata, _loop_1, type;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.currentAsset = asset;
                        self = this;
                        this.assetFormatSelector.clearThumb();
                        this.puffFormatSelector.clearThumb();
                        this.$assetInfoList.empty();
                        this.altTextUI.setAsset(asset);
                        this.captionUI.setAsset(asset);
                        if (!asset) {
                            this.enableFormatSelection();
                            this.altTextUI.setEnabled(true);
                            this.captionUI.setEnabled(true);
                            this.broker.assetInteractionUI.setEnabled(true);
                            this.assetOptimizationPanelUI.setEnabled(true);
                            self.$editButton.addClass("disabled");
                            self.$removeButton.addClass("disabled");
                            return [2];
                        }
                        assetEditable = this.isCurrentAssetEditable();
                        assetImage = this.isCurrentAssetImage();
                        this.enableFormatSelection(assetEditable);
                        this.altTextUI.setEnabled(assetImage);
                        this.captionUI.setEnabled(assetEditable);
                        this.assetOptimizationPanelUI.setEnabled(assetEditable);
                        this.broker.assetInteractionUI.setEnabled(this.isCurrentAssetImage());
                        this.assetFormatSelector.updateThumbnail();
                        this.puffFormatSelector.updateThumbnail();
                        if (assetEditable) {
                            this.$editButton.removeClass("disabled");
                        }
                        else {
                            self.$editButton.addClass("disabled");
                        }
                        this.$removeButton.removeClass("disabled");
                        this.createHeading(asset.name);
                        this.addInfo("id", asset.id);
                        return [4, this.settings.dataStore.getVault(asset.vaultId)];
                    case 1:
                        v = _a.sent();
                        self.addInfo(this.i18n("vault"), v.Name);
                        date = new Date(asset.modified);
                        self.addInfo(this.i18n("uploaded"), date.toLocaleString());
                        self.addInfo(this.i18n("uploaded-by"), asset.modifiedBy);
                        self.addInfo(this.i18n("content-type"), asset.contentType);
                        categories = "";
                        if (asset.categories && asset.categories.length) {
                            categories = asset.categories.map(function (c) { return c.name; }).join(", ");
                        }
                        self.addInfo(this.i18n("categories"), categories);
                        if (!(asset.metadata && asset.metadata.length)) return [3, 3];
                        return [4, Promise.all(asset.metadata.map(function (m) { return __awaiter(_this, void 0, void 0, function () {
                                var fm;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4, self.settings.dataStore.formatAssetMetadata(m)];
                                        case 1:
                                            fm = _a.sent();
                                            return [2, fm];
                                    }
                                });
                            }); }))];
                    case 2:
                        metadata = _a.sent();
                        _loop_1 = function (type) {
                            var data = metadata.filter(function (m) { return m.metadataDefinition.MetadataDefinitionType == Number(type); });
                            if (data.length) {
                                self.createHeading(ImageVault.MetadataDefinitionType[type]);
                                data.map(function (m) {
                                    self.addInfo(m.metadataDefinition.Name, m.formattedValue);
                                });
                            }
                            ;
                        };
                        for (type in ImageVault.MetadataDefinitionType) {
                            _loop_1(type);
                        }
                        ;
                        _a.label = 3;
                    case 3:
                        ;
                        return [2];
                }
            });
        });
    };
    InfoPanelUI.prototype.createHeading = function (heading) {
        this.$assetInfoList.append("<dt class='heading'>" + heading + "</dt>");
    };
    InfoPanelUI.prototype.addInfo = function (name, value) {
        this.$assetInfoList.append("<dt>" + ImageVault.Util.htmlEncode(name) + "</dt>");
        this.$assetInfoList.append("<dd>" + ImageVault.Util.htmlEncode(value) + "</dd>");
    };
    return InfoPanelUI;
}(ConfigUI_1.ConfigUI));
exports.InfoPanelUI = InfoPanelUI;


/***/ }),

/***/ "./src/ts/InstanceConfigUI.ts":
/*!************************************!*\
  !*** ./src/ts/InstanceConfigUI.ts ***!
  \************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var $ = __webpack_require__(/*! jquery */ "jquery");
var ConfigUI_1 = __webpack_require__(/*! ./ConfigUI */ "./src/ts/ConfigUI.ts");
var AssetInteractionUI_1 = __webpack_require__(/*! ./AssetInteractionUI */ "./src/ts/AssetInteractionUI.ts");
var InfoPanelUI_1 = __webpack_require__(/*! ./InfoPanelUI */ "./src/ts/InfoPanelUI.ts");
var DataStore_1 = __webpack_require__(/*! ./DataStore */ "./src/ts/DataStore.ts");
var SearchPanelUI_1 = __webpack_require__(/*! ./SearchPanelUI */ "./src/ts/SearchPanelUI.ts");
var MediaServiceUtilUI_1 = __webpack_require__(/*! ./MediaServiceUtilUI */ "./src/ts/MediaServiceUtilUI.ts");
var InstanceConfigUI = (function (_super) {
    __extends(InstanceConfigUI, _super);
    function InstanceConfigUI(settings) {
        return _super.call(this, settings) || this;
    }
    InstanceConfigUI.prototype.init = function (values) {
        return __awaiter(this, void 0, void 0, function () {
            var self, props, e_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        self = this;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        props = {
                            ivUrl: this.settings.config.ivUrl,
                            activationCallback: function (activationResponse) {
                                switch (activationResponse.state) {
                                    case ImageVault.ActivationResponseState.completed:
                                        self.hideActivationMessage();
                                        self.alert(activationResponse.htmlMessage, "info");
                                        break;
                                    case ImageVault.ActivationResponseState.tentative:
                                        self.showActivationMessage(activationResponse.htmlMessage);
                                        break;
                                    default:
                                        self.showActivationError(activationResponse.htmlMessage);
                                        break;
                                }
                            },
                            clientIdentityAuth: ConfigUI_1.ConfigUI.ClientIdentityAuth,
                            i18n: {
                                pin_code_request_no_valid_pin_code: self.settings.i18n.pin_client_pin_code_request_no_valid_pin_code,
                                poll_pin_failed_async_is_not_supported: self.settings.i18n.pin_client_poll_pin_failed_async_is_not_supported,
                                poll_pin_code_returned_state_x: self.settings.i18n.pin_client_poll_pin_code_returned_state_x,
                                no_access_code_was_returned_from_poll_code_response: self.settings.i18n.pin_client_no_access_code_was_returned_from_poll_code_response,
                                activation_completed: self.settings.i18n.pin_client_activation_completed,
                                activation_is_required_go_to_x_to_activate: self.settings.i18n.pin_client_activation_is_required_go_to_x_to_activate,
                            }
                        };
                        this.settings.client = new ImageVault.PinClient(props);
                        this.settings.dataStore = new DataStore_1.DataStore(this.settings.client);
                        this.settings.instanceConfig = this.getInstanceConfig(values);
                        this.$instanceSettings = $("#instance-settings");
                        this.mediaServiceUtil = new MediaServiceUtilUI_1.MediaServiceUtilUI(this.settings);
                        this.infoPanel = new InfoPanelUI_1.InfoPanelUI(this);
                        this.assetInteractionUI = new AssetInteractionUI_1.AssetInteractionUI(this.settings);
                        this.searchPanel = new SearchPanelUI_1.SearchPanelUI(this);
                        return [4, Promise.all([
                                this.mediaServiceUtil.init(),
                                this.infoPanel.init(),
                                this.assetInteractionUI.init(),
                                this.searchPanel.init()
                            ])];
                    case 2:
                        _a.sent();
                        this.$instanceSettings.show();
                        return [3, 4];
                    case 3:
                        e_1 = _a.sent();
                        this.error(this.i18n("error-during-initialization"), e_1);
                        return [3, 4];
                    case 4:
                        this.hideLoader();
                        window.validate = function () {
                            try {
                                _this.showLoader();
                                var r = self.saveSelection();
                                if (!r)
                                    return true;
                                self.error(self.i18n("error-during-validate"), r);
                                return false;
                            }
                            finally {
                                self.hideLoader();
                            }
                        };
                        window.getValues = function () {
                            var values = window._getValues();
                            var fieldsToRemove = ["imageVaultUrl",
                                "search", "categoryId", "searchOrderBy",
                                "formatAspectRatio", "formatId", "formatHeight", "formatWidth",
                                "alt-text-from-metadata-id-select", "alt-text-from-metadata-text", "alt-text-custom", "alt-text-choice",
                                "caption-from-metadata-id-select", "caption-from-metadata-text", "caption-custom", "caption-choice",
                                "clickInteraction", "clickInteractionCustomUrlData"
                            ];
                            for (var i = 0; i < fieldsToRemove.length; i++) {
                                var k = fieldsToRemove[i];
                                if (values.hasOwnProperty(k))
                                    delete values[k];
                            }
                            return values;
                        };
                        return [2];
                }
            });
        });
    };
    InstanceConfigUI.prototype.getInstanceConfig = function (values) {
        var ac = this.getValue(InstanceConfigUI.AssetConfigKey);
        var settings = {};
        if (ac) {
            settings = JSON.parse(ac);
        }
        if (values.hasOwnProperty("assetId") && !settings.id) {
            settings.id = values["assetId"];
        }
        if (values.hasOwnProperty("assetHtml") && !settings.html) {
            settings.html = values["assetHtml"];
        }
        if (values.hasOwnProperty("assetHtmlLazy") && !settings.htmlLazy) {
            settings.htmlLazy = values["assetHtmlLazy"];
        }
        if (!settings.altTextData) {
            var value = "";
            if (values.hasOwnProperty("assetAltText")) {
                value = values["assetAltText"];
            }
            var choice = "custom";
            if (values.hasOwnProperty("alt-text-choice"))
                choice = values["alt-text-choice"];
            var id = null;
            if (values.hasOwnProperty("alt-text-from-metadata-id")) {
                id = parseInt(values["alt-text-from-metadata-id"]);
            }
            var customValue = "";
            if (values.hasOwnProperty("alt-text-custom")) {
                customValue = values["alt-text-custom"];
            }
            settings.altTextData = { choice: choice, value: value, metadataId: id, customValue: customValue };
        }
        if (!settings.captionData) {
            var value = "";
            if (values.hasOwnProperty("assetCaption")) {
                value = values["assetCaption"];
            }
            var choice = "custom";
            if (values.hasOwnProperty("caption-choice"))
                choice = values["caption-choice"];
            var id = null;
            if (values.hasOwnProperty("caption-from-metadata-id")) {
                id = parseInt(values["caption-from-metadata-id"]);
            }
            var customValue = "";
            if (values.hasOwnProperty("caption-custom")) {
                customValue = values["caption-custom"];
            }
            settings.captionData = { choice: choice, value: value, metadataId: id, customValue: customValue };
        }
        if (values.hasOwnProperty("assetFormatId") && !settings.formatId) {
            settings.formatId = values["assetFormatId"];
        }
        if (values.hasOwnProperty("assetEffects") && !settings.effects) {
            var ae = values["assetEffects"];
            if (ae && typeof (ae) !== "object") {
                ae = JSON.parse(ae);
            }
            settings.effects = ae;
        }
        if (!settings.click) {
            var click = { mode: "none" };
            settings.click = click;
            if (values.hasOwnProperty("clickInteraction")) {
                settings.click.mode = values["clickInteraction"];
            }
            if (values.hasOwnProperty("clickInteractionCustomUrlData")) {
                settings.click.customUrl = values["clickInteractionCustomUrlData"];
            }
        }
        return settings;
    };
    InstanceConfigUI.prototype.selectAsset = function (asset) {
        return this.infoPanel.selectAsset(asset);
    };
    InstanceConfigUI.prototype.saveSelection = function () {
        try {
            this.updateInstanceConfig();
            this.setValue(InstanceConfigUI.AssetConfigKey, JSON.stringify(this.settings.instanceConfig));
        }
        catch (e) {
            if (e && e.error)
                return e;
            return { error: e };
        }
    };
    InstanceConfigUI.prototype.updateInstanceConfig = function () {
        var assetId = this.settings.instanceConfig.id;
        var altData = this.infoPanel.altTextUI.getData();
        if (!altData.value) {
            altData.value = "";
        }
        var captionData = this.infoPanel.captionUI.getData();
        this.settings.instanceConfig.altTextData = altData;
        this.settings.instanceConfig.captionData = captionData;
        this.settings.instanceConfig.click = this.assetInteractionUI.getClickInteractionData();
        this.settings.instanceConfig.formatId = -1;
        var formatData = this.infoPanel.assetFormatSelector.getSelectedFormatData();
        if (formatData && formatData.id >= 0) {
            this.settings.instanceConfig.formatId = formatData.id;
        }
        var effects = this.infoPanel.assetFormatSelector.getEffectsForTarget();
        this.settings.instanceConfig.puff = { formatId: -1 };
        var puffFormatData = this.infoPanel.puffFormatSelector.getSelectedFormatData();
        if (puffFormatData && puffFormatData.id >= 0) {
            this.settings.instanceConfig.puff.formatId = puffFormatData.id;
        }
        var puffEffects = this.infoPanel.puffFormatSelector.getEffectsForTarget();
        var formatTemplate = new ImageVault.ThumbnailFormat(effects);
        if (this.infoPanel.isCurrentAssetVideo()) {
            formatTemplate = new ImageVault.WebMediaFormat(effects);
        }
        formatTemplate.MediaFormatOutputType = ImageVault.MediaFormatOutputType.WebSafe;
        var puffFormat = new ImageVault.ThumbnailFormat(puffEffects);
        puffFormat.MediaFormatOutputType = ImageVault.MediaFormatOutputType.WebSafe;
        if (!assetId) {
            this.settings.instanceConfig.html = null;
            return;
        }
        var publishIdentifier = "ImageVault_Connect_SiteVision_App";
        if (/^((?:\w+:|)\/\/[^\/]+)/.test(this.settings.pageInfo.url)) {
            publishIdentifier = RegExp.$1.toLocaleLowerCase();
        }
        var publishDetails = {
            GroupId: publishIdentifier,
            Text: this.settings.pageInfo.name,
            Url: this.settings.pageInfo.url
        };
        var q = {
            Filter: { Id: [assetId] },
            Populate: {
                MediaFormats: [formatTemplate, puffFormat],
                PublishInfo: { PublishIdentifier: publishIdentifier, PublishDetails: JSON.stringify(publishDetails) }
            },
            MediaUrlBase: this.settings.config.ivUrl
        };
        var maxWidth = this.infoPanel.getCurrentAssetWidth();
        for (var i = 0; effects && i < effects.length; i++) {
            var e = effects[0];
            if (!e.$type)
                continue;
            if (e.$type.startsWith(ImageVault.ResizeEffect.typeName)) {
                var re = e;
                if (re.Width && re.Width < maxWidth)
                    maxWidth = re.Width;
                continue;
            }
            if (e.$type.startsWith(ImageVault.CropEffect.typeName)) {
                var ce = e;
                if (ce.Width && ce.Width < maxWidth)
                    maxWidth = ce.Width;
                continue;
            }
        }
        var srcSetLimits = [320, 640, 960, 1280, 1600, 1920];
        var useSrcSet = this.getBooleanValue("SrcSet") && this.infoPanel.isCurrentAssetImage() && maxWidth > srcSetLimits[0];
        if (useSrcSet) {
            for (var i = 0; i < srcSetLimits.length; i++) {
                if (srcSetLimits[i] >= maxWidth) {
                    srcSetLimits[i] = maxWidth;
                    srcSetLimits = srcSetLimits.slice(0, i + 1);
                    break;
                }
            }
            for (var i = 0; i < srcSetLimits.length; i++) {
                var resizeEffect = new ImageVault.ResizeEffect(srcSetLimits[i], 0, 0);
                var format = JSON.parse(JSON.stringify(formatTemplate));
                format.Effects.push(resizeEffect);
                q.Populate.MediaFormats.push(format);
            }
        }
        if (!this.infoPanel.isCurrentAssetEditable()) {
            q.Populate.MediaFormats = [new ImageVault.OriginalFormat()];
        }
        var mediaItems = ImageVault.MediaService.FindSync(this.settings.client, q);
        if (!mediaItems) {
            throw this.i18n("no-response-was-received");
        }
        if (!mediaItems || !mediaItems.length) {
            throw this.i18n("no-asset-with-id-x-was-found", assetId);
        }
        var mediaItem = mediaItems[0];
        var conversions = mediaItem.MediaConversions;
        if (!conversions || !conversions.length) {
            throw this.i18n("the-requested-conversion-for-asset-x-could-not-be-retrieved", assetId);
        }
        var lazyLoad = this.getBooleanValue("LazyLoad");
        var c = conversions[0];
        var html = c.Html;
        var htmlLazy = "";
        if (c.ContentType.toLocaleLowerCase().startsWith("image/")) {
            var $e = $("<img/>");
            $e.addClass("sv-noborder");
            $e.attr("src", c.Url);
            $e.css("width", "100%");
            if (c.Width) {
                $e.css("max-width", c.Width + "px");
            }
            if (c.Height) {
                $e.css("max-height", c.Height + "px");
            }
            var srcSet = "";
            if (useSrcSet) {
                for (var i = 0; i < srcSetLimits.length; i++) {
                    if (conversions.length <= i + 2)
                        break;
                    var sWidth = srcSetLimits[i];
                    var media = conversions[i + 2];
                    if (srcSet)
                        srcSet += ", ";
                    srcSet += media.Url + "?w=" + sWidth + " " + sWidth + "w";
                }
                if (srcSet) {
                    $e.attr("srcset", srcSet);
                    $e.attr("sizes", "100vw");
                }
            }
            $e.attr("alt", altData.value);
            html = $e[0].outerHTML;
            if (lazyLoad) {
                $e.attr("data-src", c.Url);
                $e.addClass("sv-lazy-load-img");
                var lazyLoadUrl = "";
                if (c.Width && c.Height) {
                    lazyLoadUrl = "data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 " + c.Width + " " + c.Height + "'%3E%3C/svg%3E";
                }
                $e.attr("src", lazyLoadUrl);
                if (srcSet) {
                    $e.attr("data-srcset", srcSet);
                    $e.removeAttr("srcset");
                }
                htmlLazy = $e[0].outerHTML;
            }
        }
        else {
            var $e = $(html);
            if ($e[0].tagName.toLocaleLowerCase() === "video") {
                $e.css("width", "100%");
                if (c.Width) {
                    $e.css("max-width", c.Width + "px");
                }
                if (c.Height) {
                    $e.css("max-height", c.Height + "px");
                }
                html = $e[0].outerHTML;
            }
        }
        if (!html)
            throw this.i18n("the-requested-conversion-for-asset-x-has-no-html", assetId);
        this.settings.instanceConfig.html = html;
        this.settings.instanceConfig.htmlLazy = htmlLazy;
        var puff = conversions[1];
        this.settings.instanceConfig.puff.html = puff.Html;
        return;
    };
    InstanceConfigUI.AssetConfigKey = "assetConfig";
    return InstanceConfigUI;
}(ConfigUI_1.ConfigUI));
exports.InstanceConfigUI = InstanceConfigUI;


/***/ }),

/***/ "./src/ts/MediaServiceUtilUI.ts":
/*!**************************************!*\
  !*** ./src/ts/MediaServiceUtilUI.ts ***!
  \**************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ConfigUI_1 = __webpack_require__(/*! ./ConfigUI */ "./src/ts/ConfigUI.ts");
var MediaServiceUtilUI = (function (_super) {
    __extends(MediaServiceUtilUI, _super);
    function MediaServiceUtilUI(settings) {
        return _super.call(this, settings) || this;
    }
    MediaServiceUtilUI.prototype.init = function () { };
    MediaServiceUtilUI.prototype.isSearchEngineEnabled = function () {
        return __awaiter(this, void 0, void 0, function () {
            var r, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!this.searchMethod) return [3, 4];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, ImageVault.AssetService.info(this.settings.client)];
                    case 2:
                        r = _a.sent();
                        this.searchMethod = (r.searchEnabled ? 1 : 2);
                        return [3, 4];
                    case 3:
                        e_1 = _a.sent();
                        this.logResult("ERROR", "Failed to lookup assets/info " + e_1);
                        this.searchMethod = 2;
                        return [3, 4];
                    case 4: return [2, this.searchMethod === 1];
                }
            });
        });
    };
    MediaServiceUtilUI.prototype.getAsset = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.isSearchEngineEnabled()];
                    case 1:
                        if (!_a.sent()) return [3, 3];
                        return [4, ImageVault.AssetService.get(this.settings.client, { $filter: "id eq '" + id + "'" })];
                    case 2: return [2, _a.sent()];
                    case 3: return [4, this.getUsingMediaService(id)];
                    case 4: return [2, _a.sent()];
                }
            });
        });
    };
    MediaServiceUtilUI.prototype.getUsingMediaService = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var q, r, re;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        q = {
                            Filter: {
                                Id: [id]
                            },
                            Populate: {
                                MediaFormats: [
                                    {},
                                ],
                                Metadata: [{ Filter: { IsNull: false } }],
                                Agreements: true,
                                Categories: true
                            },
                            MediaUrlBase: null
                        };
                        return [4, ImageVault.MediaService.Find(this.settings.client, q)];
                    case 1:
                        r = _a.sent();
                        re = {
                            "@odata.count": 0,
                            value: []
                        };
                        if (!r) {
                            return [2, re];
                        }
                        re.value = this.convertMediaItemsToIAssets(r);
                        re["@odata.count"] = re.value.length;
                        return [2, re];
                }
            });
        });
    };
    MediaServiceUtilUI.prototype.search = function (request, categoryId) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.isSearchEngineEnabled()];
                    case 1:
                        if (!_a.sent()) return [3, 3];
                        return [4, ImageVault.AssetService.get(this.settings.client, request)];
                    case 2: return [2, _a.sent()];
                    case 3: return [4, this.searchUsingMediaService(request, categoryId)];
                    case 4: return [2, _a.sent()];
                }
            });
        });
    };
    MediaServiceUtilUI.prototype.searchUsingMediaService = function (request, categoryId) {
        return __awaiter(this, void 0, void 0, function () {
            var q, r, re, moreResultExists;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        q = {
                            Filter: {
                                SearchString: request.$search,
                                Skip: request.$skip,
                                Take: request.$top + 1,
                                SortOrder: ImageVault.MediaItemSortOrders.DateAddedDescending,
                                CategoryId: categoryId
                            },
                            Populate: {
                                MediaFormats: [
                                    {},
                                    new ImageVault.ThumbnailFormat([new ImageVault.ResizeEffect(200, 200, 0)])
                                ],
                                Metadata: [{ Filter: { IsNull: false } }],
                                Agreements: true,
                                Categories: true
                            },
                            MediaUrlBase: null
                        };
                        if (request.$orderby) {
                            switch (request.$orderby) {
                                case "name":
                                    q.Filter.SortOrder = ImageVault.MediaItemSortOrders.Name;
                                    break;
                                case "name desc":
                                    q.Filter.SortOrder = ImageVault.MediaItemSortOrders.NameDescending;
                                    break;
                                case "modified":
                                    q.Filter.SortOrder = ImageVault.MediaItemSortOrders.DateAdded;
                                    break;
                                case "modified desc":
                                    q.Filter.SortOrder = ImageVault.MediaItemSortOrders.DateAddedDescending;
                                    break;
                                default:
                                    this.logResult("WARNING", "Unknown sort order " + request.$orderby);
                                    break;
                            }
                        }
                        return [4, ImageVault.MediaService.Find(this.settings.client, q)];
                    case 1:
                        r = _a.sent();
                        re = {
                            "@odata.count": request.$skip || 0,
                            value: []
                        };
                        if (!r) {
                            return [2, re];
                        }
                        moreResultExists = r.length > request.$top;
                        if (moreResultExists) {
                            r = r.slice(0, request.$top);
                        }
                        re["@odata.count"] += r.length + (moreResultExists ? 1 : 0);
                        re.value = this.convertMediaItemsToIAssets(r);
                        return [2, re];
                }
            });
        });
    };
    MediaServiceUtilUI.prototype.convertMediaItemsToIAssets = function (r) {
        var _this = this;
        return r.map(function (mi) {
            var asset = {};
            asset.id = mi.Id.toString();
            asset.name = mi.Name;
            asset.vaultId = mi.VaultId;
            asset.modified = mi.DateAdded;
            asset.modifiedBy = mi.AddedBy;
            asset.symbols = [];
            asset.metadata = [];
            var symbols = {};
            if (mi.Metadata && mi.Metadata.length) {
                asset.metadata = mi.Metadata.map(function (md) {
                    if (!md || md.IsNull)
                        return null;
                    var am = {
                        definitionId: md.MetadataDefinitionId,
                        value: (md.Value || "").toString()
                    };
                    var symbolKey = md.SymbolKey;
                    if (md.$type.startsWith("ImageVault.Common.Data.MetadataBoolean")) {
                        am.booleanValue = md.Value;
                        if (!am.booleanValue) {
                            symbolKey = null;
                        }
                    }
                    else if (md.$type.startsWith("ImageVault.Common.Data.MetadataDecimal")) {
                        am.doubleValue = md.Value;
                    }
                    else if (md.$type.startsWith("ImageVault.Common.Data.MetadataDateTime")) {
                        am.dateValue = am.value;
                    }
                    else if (md.$type.startsWith("ImageVault.Common.Data.MetadataInteger")) {
                        am.integerValue = md.Value;
                    }
                    if (symbolKey) {
                        var list = symbols[symbolKey];
                        if (!list) {
                            list = [];
                            symbols[symbolKey] = list;
                        }
                        var info = {
                            name: md.Name,
                            value: md.Value
                        };
                        list.push(info);
                    }
                    return am;
                }).filter(function (a) { return a != null; });
            }
            Object.keys(symbols).map(function (k) {
                var as = {
                    symbol: k,
                    info: symbols[k]
                };
                asset.symbols.push(as);
            });
            var agreementSymbol = _this.getAgreementSymbol(mi.Agreements);
            if (agreementSymbol)
                asset.symbols.push(agreementSymbol);
            asset.conversions = [];
            if (mi.MediaConversions && mi.MediaConversions.length) {
                var original = mi.MediaConversions[0];
                mi.MediaConversions = mi.MediaConversions.slice(1);
                asset.conversions = mi.MediaConversions.map(function (mc) {
                    var wm = mc;
                    var ac = {
                        formatId: mc.MediaFormatId,
                        contentType: mc.ContentType,
                        height: wm.Height,
                        width: wm.Width,
                        url: mc.Url,
                        mediaInformation: null
                    };
                    return ac;
                });
                if (original) {
                    asset.contentType = original.ContentType;
                }
            }
            asset.categories = [];
            if (mi.Categories && mi.Categories.length) {
                asset.categories = mi.Categories.map(function (c) {
                    return {
                        id: c.Id,
                        name: c.Name
                    };
                });
            }
            return asset;
        });
    };
    MediaServiceUtilUI.prototype.getAgreementSymbol = function (agreements) {
        if (!agreements || !agreements.length)
            return null;
        var now = new Date();
        if (this.hasAgreementPassingValidDate(agreements, now)) {
            return { symbol: "expired", info: [{ name: this.i18n("has_expired_agreements") }] };
        }
        var soonExpired = new Date();
        soonExpired.setMonth(soonExpired.getMonth() + 3);
        if (this.hasAgreementPassingValidDate(agreements, soonExpired)) {
            return { symbol: "soonexpired", info: [{ name: this.i18n("has_soon_expired_agreements") }] };
        }
        return { symbol: "valid", info: [{ name: this.i18n("all_agreements_are_valid") }] };
    };
    MediaServiceUtilUI.prototype.hasAgreementPassingValidDate = function (agreements, validDate) {
        var expired = agreements.filter(function (a) {
            var date = new Date(a.ValidToDate);
            return date < validDate;
        });
        return !!expired.length;
    };
    return MediaServiceUtilUI;
}(ConfigUI_1.ConfigUI));
exports.MediaServiceUtilUI = MediaServiceUtilUI;


/***/ }),

/***/ "./src/ts/MetadataTextUI.ts":
/*!**********************************!*\
  !*** ./src/ts/MetadataTextUI.ts ***!
  \**********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var ConfigPanelUI_1 = __webpack_require__(/*! ./ConfigPanelUI */ "./src/ts/ConfigPanelUI.ts");
var MetadataTextUI = (function (_super) {
    __extends(MetadataTextUI, _super);
    function MetadataTextUI(settings, name, data, required) {
        var _this = _super.call(this, settings, name + "-metadata-text-panel") || this;
        _this.name = name;
        _this.required = required || false;
        _this.data = data || { choice: "custom" };
        _this.choiceKey = _this.name + "-choice";
        return _this;
    }
    MetadataTextUI.prototype.getNamedElement = function (id) {
        var identifier = this.name + "-" + id;
        var $j = $("#" + identifier);
        if ($j.length !== 1) {
            throw "cannot find DOM element with id " + identifier;
        }
        return $j;
    };
    MetadataTextUI.prototype.init = function () {
        var self = this;
        this.$choiceCustomDetails = this.getNamedElement("choice-custom-details");
        this.$choiceMetadataDetails = this.getNamedElement("choice-metadata-details");
        this.$metadataDefinitionsSelect = this.getNamedElement("from-metadata-id-select");
        this.$metadataValue = this.getInput(this.name + "-from-metadata-text");
        this.$customValueInput = this.getInput(this.name + "-custom");
        this.$panel = this.$customValueInput.closest("div.panel");
        var choice = this.data.choice;
        if (choice !== "metadata" && choice !== "none") {
            choice = "custom";
        }
        if (this.required) {
            if (choice === "none")
                choice = "custom";
            var $noneAlternativeRow = $("#" + this.name + "-choice-none").closest("div.row");
            $noneAlternativeRow.hide();
        }
        this.setValue(this.choiceKey, choice);
        this.setValue(this.$customValueInput, this.data.customValue);
        this.updateDetailsUI();
        this.updateMetadataSelect()
            .then(function () {
            if (self.data.metadataId) {
                self.setValue(self.$metadataDefinitionsSelect, self.data.metadataId);
            }
        })
            .then(function () { return self.updateMetadataValue(); })
            .then(function () {
            self.$metadataDefinitionsSelect.change(function () {
                self.saveSelectedMetadataDefinition();
                self.updateMetadataValue().catch(function (e) { self.error(self.i18n("e-003-failed-to-update-metadata-value"), e); });
            });
        }).catch(function (e) {
            self.error(self.i18n("e-004-failed-to-retrieve-metadata-definitions"), e);
        });
        this.getInput(this.choiceKey).change(function () {
            self.updateDetailsUI();
        });
    };
    MetadataTextUI.prototype.saveSelectedMetadataDefinition = function () {
        var id = this.getIntValue(this.$metadataDefinitionsSelect);
        this.data.metadataId = id;
    };
    MetadataTextUI.prototype.setAsset = function (asset) {
        this.asset = asset;
        return this.updateMetadataValue();
    };
    MetadataTextUI.prototype.updateMetadataValue = function () {
        var self = this;
        return new Promise(function (resolve) {
            var id = self.data.metadataId;
            if (id && self.asset) {
                var matchingMetadata = self.asset.metadata.filter((function (m) { return m.definitionId === id; }));
                if (matchingMetadata && matchingMetadata.length > 0) {
                    self.settings.dataStore.formatAssetMetadata(matchingMetadata[0]).then(function (fm) {
                        self.$metadataValue.val(fm.formattedValue);
                        resolve();
                    });
                    return;
                }
            }
            self.$metadataValue.val("");
            resolve();
        });
    };
    MetadataTextUI.prototype.updateMetadataSelect = function () {
        var self = this;
        var oldValue = this.data.metadataId;
        return new Promise(function (resolve) {
            self.settings.dataStore.getAllMetadataDefinitions().then(function (metadataDefinitions) {
                self.$metadataDefinitionsSelect.empty();
                metadataDefinitions.map(function (md) {
                    var $o = $("<option></option>");
                    $o.attr("value", md.Id);
                    $o.text(ImageVault.MetadataDefinitionType[md.MetadataDefinitionType] + " - " + md.Name);
                    self.$metadataDefinitionsSelect.append($o);
                });
                self.setValue(self.$metadataDefinitionsSelect, oldValue);
                if (self.$metadataDefinitionsSelect[0].selectedIndex < 0) {
                    self.$metadataDefinitionsSelect[0].selectedIndex = 0;
                    self.saveSelectedMetadataDefinition();
                }
                resolve();
            });
        });
    };
    MetadataTextUI.prototype.updateDetailsUI = function () {
        var choice = this.getValue(this.choiceKey);
        this.$choiceCustomDetails.hide();
        this.$choiceMetadataDetails.hide();
        switch (choice) {
            case "custom":
                this.$choiceCustomDetails.show();
                break;
            case "metadata":
                this.$choiceMetadataDetails.show();
                break;
        }
    };
    MetadataTextUI.prototype.getData = function () {
        var choice = this.getValue(this.choiceKey);
        var value = "";
        var metadataValue = this.getValue(this.$metadataValue);
        var customValue = this.getValue(this.$customValueInput);
        var id = this.data.metadataId;
        switch (choice) {
            case "custom":
                value = customValue;
                break;
            case "metadata":
                value = metadataValue;
                break;
            case "none":
                value = "";
                break;
        }
        if (this.required && !value) {
            this.$panel.addClass("has-error");
            throw this.i18n('metadata-text-value-required');
        }
        else {
            this.$panel.removeClass("has-error");
        }
        return { choice: choice, customValue: customValue, metadataId: id, value: value };
    };
    return MetadataTextUI;
}(ConfigPanelUI_1.ConfigPanelUI));
exports.MetadataTextUI = MetadataTextUI;


/***/ }),

/***/ "./src/ts/SearchPanelUI.ts":
/*!*********************************!*\
  !*** ./src/ts/SearchPanelUI.ts ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ConfigUI_1 = __webpack_require__(/*! ./ConfigUI */ "./src/ts/ConfigUI.ts");
var CategoryFilterUI_1 = __webpack_require__(/*! ./CategoryFilterUI */ "./src/ts/CategoryFilterUI.ts");
var VersionUtil_1 = __webpack_require__(/*! ./VersionUtil */ "./src/ts/VersionUtil.ts");
var SearchPanelUI = (function (_super) {
    __extends(SearchPanelUI, _super);
    function SearchPanelUI(broker) {
        var _this = _super.call(this, broker.settings) || this;
        _this.currentSearchPage = 0;
        _this.moreSearchPagesExists = false;
        _this.broker = broker;
        return _this;
    }
    SearchPanelUI.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var self;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        self = this;
                        this.$assets = $("#assets");
                        this.$assetsDiv = $("#assets-div");
                        this.$searchLoader = $("#search-loader");
                        this.$searchTextBox = this.getInput("search");
                        this.$searchOrderBySelect = this.getInput("searchOrderBy");
                        this.$searchButton = $("#search");
                        this.categoryFilterUI = new CategoryFilterUI_1.CategoryFilterUI(this.broker.settings, function () {
                            self.updateHeight();
                            self.search(false);
                        });
                        this.categoryFilterUI.init();
                        this.setValue(this.$searchTextBox, "");
                        this.setValue(this.$searchOrderBySelect, this.getDefaultSearchOrder());
                        this.$searchOrderBySelect.change(function () {
                            self.setSearchOrderBy(self.getValue(self.$searchOrderBySelect));
                            self.search(false);
                        });
                        this.$searchButton.click(function (e) {
                            e.preventDefault();
                            self.search();
                            return false;
                        });
                        this.$searchTextBox.keypress(function (event) {
                            var keycode = (event.keyCode ? event.keyCode : event.which);
                            if (keycode == 13) {
                                self.search();
                                return false;
                            }
                        });
                        this.$assetsDiv.scroll(function () {
                            if (!self.moreSearchPagesExists)
                                return;
                            var height = self.$assets.height();
                            var outerHeight = self.$assetsDiv.height();
                            var scrollTop = self.$assetsDiv.scrollTop();
                            var loadMargin = 100;
                            if (scrollTop + outerHeight + loadMargin > height) {
                                self.search(true);
                            }
                        });
                        return [4, this.search()];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    SearchPanelUI.prototype.updateHeight = function () {
        var categoryDivHeight = this.categoryFilterUI.getCategoryComponentHeight();
        var otherComponentsHeight = 165;
        this.$assetsDiv.css("height", "calc(100vh - " + (categoryDivHeight + otherComponentsHeight) + "px)");
    };
    SearchPanelUI.prototype.setSearchOrderBy = function (orderBy) {
        if (orderBy !== this.getDefaultSearchOrder()) {
            this.overrideDefaultOrderBy = orderBy;
        }
        else {
            this.overrideDefaultOrderBy = null;
        }
    };
    SearchPanelUI.prototype.getDefaultSearchOrder = function () {
        return __awaiter(this, void 0, void 0, function () {
            var search, defaultSearchOrder, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        search = this.getValue(this.$searchTextBox);
                        defaultSearchOrder = "modified desc";
                        _a = search;
                        if (!_a) return [3, 2];
                        return [4, this.broker.mediaServiceUtil.isSearchEngineEnabled()];
                    case 1:
                        _a = (_b.sent());
                        _b.label = 2;
                    case 2:
                        if (_a) {
                            defaultSearchOrder = "";
                        }
                        return [2, defaultSearchOrder];
                }
            });
        });
    };
    SearchPanelUI.prototype.ensureMatchSearchOrderExists = function (ensure) {
        var firstChild = this.$searchOrderBySelect.children().first();
        var firstChildIsMatchSearchOrder = firstChild.val() === "";
        if (ensure == firstChildIsMatchSearchOrder)
            return;
        if (ensure) {
            this.$searchOrderBySelect.prepend("<option value=''>" + this.i18n("order-by-match") + "</option>");
        }
        else {
            this.$searchOrderBySelect.children().first().remove();
        }
    };
    SearchPanelUI.prototype.getCurrentActiveSearchOrder = function () {
        return __awaiter(this, void 0, void 0, function () {
            var order, newOrder, defaultSearchOrder;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        order = this.getValue(this.$searchOrderBySelect);
                        newOrder = order;
                        return [4, this.getDefaultSearchOrder()];
                    case 1:
                        defaultSearchOrder = _a.sent();
                        this.ensureMatchSearchOrderExists(defaultSearchOrder === "");
                        if (this.overrideDefaultOrderBy) {
                            newOrder = this.overrideDefaultOrderBy;
                        }
                        else if (order != defaultSearchOrder) {
                            newOrder = defaultSearchOrder;
                        }
                        if (newOrder != order) {
                            order = newOrder;
                            this.setValue(this.$searchOrderBySelect, order);
                        }
                        return [2, order];
                }
            });
        });
    };
    SearchPanelUI.prototype.search = function (nextPage) {
        return __awaiter(this, void 0, void 0, function () {
            var self, search, order, pageSize, skip, q, catId, version, r, $ul, hits, accessToken, imageQs, i, item, name, conversionInfo, symbolHtml, r_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        self = this;
                        this.moreSearchPagesExists = false;
                        search = this.getValue(this.$searchTextBox);
                        return [4, this.getCurrentActiveSearchOrder()];
                    case 1:
                        order = _a.sent();
                        pageSize = 25;
                        if (nextPage) {
                            this.currentSearchPage++;
                        }
                        else {
                            this.currentSearchPage = 0;
                            this.searchHits = [];
                        }
                        this.$searchLoader.show();
                        if (this.currentSearchPage === 0)
                            $("li:not(#search-loader)", self.$assets).remove();
                        this.alert(self.i18n("searching"), "info");
                        skip = this.currentSearchPage * pageSize;
                        q = {
                            $search: search,
                            $filter: "isOrganized",
                            $top: pageSize,
                            $skip: skip,
                            $count: true,
                            $select: "id,conversions,name,symbols,contentType,metadata,agreementId,vaultId,modified,modifiedBy"
                        };
                        catId = this.categoryFilterUI.getSelectedCategories();
                        if (catId && catId.length) {
                            catId.map(function (id) { q.$filter += " and categoryId/any(c: c eq " + id + ")"; });
                        }
                        return [4, this.settings.dataStore.getVersion()];
                    case 2:
                        version = _a.sent();
                        if (VersionUtil_1.VersionUtil.verifyMinVersion(version, "5.11.147")) {
                            q.$select += ",categories";
                        }
                        if (order) {
                            q.$orderby = order;
                        }
                        _a.label = 3;
                    case 3:
                        _a.trys.push([3, 5, , 6]);
                        return [4, this.broker.mediaServiceUtil.search(q, catId)];
                    case 4:
                        r = _a.sent();
                        $ul = self.$assets;
                        hits = r["@odata.count"];
                        if (hits === 0) {
                            self.alert(self.i18n("search-returned-0-results"), "warning");
                            self.$searchLoader.hide();
                            return [2];
                        }
                        if (!r.value || !r.value.length) {
                            self.alert(self.i18n("search-yielded-no-additional-results"));
                            self.$searchLoader.hide();
                            return [2];
                        }
                        this.searchHits = this.searchHits.concat(r.value);
                        accessToken = self.settings.client.getCachedAccessToken();
                        imageQs = "?ivauthorization=" + encodeURIComponent(accessToken);
                        for (i = 0; i < r.value.length; i++) {
                            item = r.value[i];
                            name = item.name;
                            conversionInfo = self.findConversionAndResize(item, 200, imageQs);
                            if (item.symbols.filter(function (s) { return s.symbol === "expired"; }).length) {
                                item.symbols = item.symbols.filter(function (s) { return s.symbol !== "soonexpired" && s.symbol !== "valid"; });
                            }
                            else if (item.symbols.filter(function (s) { return s.symbol === "soonexpired"; }).length) {
                                item.symbols = item.symbols.filter(function (s) { return s.symbol !== "valid"; });
                            }
                            symbolHtml = item.symbols.map(function (s) {
                                var description = "";
                                if (s.info && s.info.length) {
                                    description = "<div class='symbol-description'>" + s.info.map(function (d) { return "<strong>" + ImageVault.Util.htmlEncode(d.name) + "</strong><p>" + ImageVault.Util.htmlEncode(d.value) + "</p>"; }).join("<br/>") + "</div>";
                                }
                                return "<div class='symbol symbol-" + s.symbol + "'><i class='icon icon-" + s.symbol + "'></i>" + description + "</div>";
                            }).join("");
                            $("<li data-id='" + item.id + "'><div class='symbols'>" + symbolHtml + "</div><img src='" + ImageVault.Util.htmlEncode(conversionInfo.url) + "' width='" + conversionInfo.width + "' height='" + conversionInfo.height + "' title='" + ImageVault.Util.htmlEncode(name) + "'/></li>")
                                .insertBefore(self.$searchLoader);
                        }
                        self.alert(self.i18n("displaying-first-x-assets-of-y-hits", (skip + r.value.length), hits), "success");
                        if (hits > skip + pageSize) {
                            self.moreSearchPagesExists = true;
                        }
                        $ul.off("click").on("click", "li", function () {
                            var $li = $(this);
                            if ($li.is("#search-loader"))
                                return;
                            var id = $li.data("id");
                            $("li", self.$assets).removeClass("selected");
                            $li.addClass("selected");
                            self.alert(self.i18n("asset-x-selected", id), "info");
                            var index = self.$assets.children().index(this);
                            var asset = self.searchHits[index];
                            self.broker.selectAsset(asset);
                        });
                        self.$searchLoader.hide();
                        return [3, 6];
                    case 5:
                        r_1 = _a.sent();
                        self.$searchLoader.hide();
                        self.error(self.i18n("error-performing-search"), r_1);
                        return [3, 6];
                    case 6: return [2];
                }
            });
        });
    };
    SearchPanelUI.prototype.findConversionAndResize = function (asset, targetSize, imageQs) {
        if (!imageQs) {
            var accessToken = this.settings.client.getCachedAccessToken();
            imageQs = "?ivauthorization=" + encodeURIComponent(accessToken);
        }
        var conversion = this.findClosestConversion(asset.conversions, targetSize);
        if (!conversion)
            return null;
        var url = this.settings.config.ivUrl + "apiv2/mediastreamservice" + conversion.url + imageQs;
        var ar = 1.0 * conversion.width / conversion.height;
        var targetSize, height, width;
        if (ar < 1) {
            height = targetSize;
            width = Math.round(ar * height);
        }
        else {
            width = targetSize;
            height = Math.round(targetSize / ar);
        }
        return { conversion: conversion, url: url, width: width, height: height };
    };
    SearchPanelUI.prototype.findClosestConversion = function (conversions, width) {
        if (conversions.length === 0)
            return null;
        var closestConversion = conversions[0];
        var closestDiff = Math.abs(conversions[0].width - width);
        for (var i = 1; i < conversions.length; i++) {
            var newConversion = conversions[i];
            var newDiff = Math.abs(newConversion.width - width);
            if (closestDiff < newDiff)
                continue;
            closestConversion = newConversion;
            closestDiff = newDiff;
        }
        return closestConversion;
    };
    return SearchPanelUI;
}(ConfigUI_1.ConfigUI));
exports.SearchPanelUI = SearchPanelUI;


/***/ }),

/***/ "./src/ts/ThumbSelectorUI.ts":
/*!***********************************!*\
  !*** ./src/ts/ThumbSelectorUI.ts ***!
  \***********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ConfigUI_1 = __webpack_require__(/*! ./ConfigUI */ "./src/ts/ConfigUI.ts");
var ThumbSelectorUI = (function (_super) {
    __extends(ThumbSelectorUI, _super);
    function ThumbSelectorUI(broker, props) {
        var _this = _super.call(this, broker.settings) || this;
        _this.broker = broker;
        _this.props = props;
        _this.formatSelectorEnabled = true;
        return _this;
    }
    ThumbSelectorUI.prototype.init = function () {
        var self = this;
        this.$formatSelect = this.getInput(this.props.prefix + "-formatId");
        this.$formatWidth = this.getInput(this.props.prefix + "-formatWidth");
        this.$formatHeight = this.getInput(this.props.prefix + "-formatHeight");
        this.$formatAspectRatio = this.getInput(this.props.prefix + "-formatAspectRatio");
        this.$thumbnailLoader = $("#" + this.props.prefix + "-thumb-loader");
        this.$thumbnailLoaderSpinner = $(".spinner", this.$thumbnailLoader);
        this.$thumbnailLoaderErrorMessage = $(".alert", this.$thumbnailLoader);
        this.$thumbImg = $("img#" + this.props.prefix + "-thumb");
        this.$assetEditor = $("#asset-editor");
        this.$formatSelect.change(function () {
            var selectedFormat = self.getSelectedFormatDataInner();
            var width, height;
            if (selectedFormat.width)
                width = selectedFormat.width.toString();
            if (selectedFormat.height)
                height = selectedFormat.height.toString();
            if (width)
                width += " px";
            if (height)
                height += " px";
            self.$formatWidth.val(width);
            self.$formatHeight.val(height);
            if (selectedFormat.resizeMode) {
                self.$formatAspectRatio.val(selectedFormat.aspectRatioText);
            }
            else {
                self.$formatAspectRatio.val("");
            }
            self.updateThumbnail();
        });
    };
    ThumbSelectorUI.prototype.getEffectsForTarget = function () {
        var effects = this.settings.instanceConfig.effects || [];
        effects = effects.slice();
        var format = this.getSelectedFormatData();
        if (format && (format.width || format.height)) {
            var resizeEffect = new ImageVault.ResizeEffect(0, 0, 0);
            resizeEffect.Width = format.width;
            resizeEffect.Height = format.height;
            resizeEffect.ResizeMode = format.resizeMode;
            var resizeAlreadyAdded = false;
            var lastEffect = null;
            if (effects.length > 0) {
                lastEffect = effects[effects.length - 1];
                if (lastEffect.$type === resizeEffect.$type) {
                    var lastResize = lastEffect;
                    if (lastResize.Width == resizeEffect.Width && lastResize.Height == resizeEffect.Height && lastResize.ResizeMode == resizeEffect.ResizeMode)
                        resizeAlreadyAdded = true;
                }
            }
            if (!resizeAlreadyAdded)
                effects.push(resizeEffect);
        }
        return effects;
    };
    ThumbSelectorUI.prototype.getSelectedFormatData = function () {
        if (!this.formatSelectorEnabled)
            return null;
        return this.getSelectedFormatDataInner();
    };
    ThumbSelectorUI.prototype.getSelectedFormatDataInner = function () {
        var $option = this.$formatSelect.find(":selected");
        var width = 0;
        var id = this.getIntValue(this.$formatSelect);
        if ($option.data("width"))
            width = Math.round(parseFloat($option.data("width")));
        var height = 0;
        if ($option.data("height"))
            height = Math.round(parseFloat($option.data("height")));
        var resizeMode = parseInt($option.data("resizeMode"));
        var aspectRatioText = $option.data("aspectRatioText");
        var formatData = { id: id, width: width, height: height, resizeMode: resizeMode, aspectRatioText: aspectRatioText };
        return formatData;
    };
    ThumbSelectorUI.prototype.enable = function (enable) {
        this.formatSelectorEnabled = enable;
    };
    ThumbSelectorUI.prototype.updateFormats = function () {
        return __awaiter(this, void 0, void 0, function () {
            var self, q, suggestedFormatId, closestFormatDiff, formats, i, f, width, height, resizeMode, aspectRatioText, aspectRatio, fw, fh, formatDiff, $o, currentFormatId, r_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        self = this;
                        q = {
                            Filter: {
                                Format: {
                                    SystemFormat: false
                                }
                            }
                        };
                        suggestedFormatId = 0;
                        closestFormatDiff = -1;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, ImageVault.MediaFormatService.Find(self.settings.client, q)];
                    case 2:
                        formats = _a.sent();
                        self.$formatSelect.empty();
                        self.$formatSelect.append('<option value="0">Original</option>');
                        for (i = 0; i < formats.length; i++) {
                            f = formats[i];
                            width = void 0;
                            height = void 0;
                            resizeMode = 0;
                            if (f.Width)
                                width = f.Width;
                            if (f.Height)
                                height = f.Height;
                            if (f.AspectRatio) {
                                if (width) {
                                    height = width / f.AspectRatio;
                                    resizeMode = 1;
                                }
                                else if (height) {
                                    width = height * f.AspectRatio;
                                    resizeMode = 1;
                                }
                            }
                            aspectRatioText = "";
                            if (resizeMode) {
                                aspectRatio = width / height;
                                aspectRatioText = this.calculateAspectRatioDisplayValue(aspectRatio);
                            }
                            fw = width || height;
                            fh = height || width;
                            if (fw && fh) {
                                formatDiff = Math.abs(this.props.targetSize - fw) + Math.abs(this.props.targetSize - fh);
                                if (closestFormatDiff < 0 || formatDiff < closestFormatDiff) {
                                    closestFormatDiff = formatDiff;
                                    suggestedFormatId = f.Id;
                                }
                            }
                            $o = $("<option></option>")
                                .attr("value", f.Id)
                                .data("width", (width ? width.toString() : ""))
                                .data("height", (height ? height.toString() : ""))
                                .data("resizeMode", resizeMode)
                                .data("aspectRatioText", aspectRatioText)
                                .text(f.Name);
                            self.$formatSelect.append($o);
                        }
                        currentFormatId = self.props.data.formatId;
                        if (currentFormatId === undefined || currentFormatId === null || currentFormatId < 0) {
                            currentFormatId = suggestedFormatId;
                        }
                        self.$formatSelect.val(currentFormatId);
                        self.$formatSelect.trigger("change");
                        return [3, 4];
                    case 3:
                        r_1 = _a.sent();
                        self.error(self.i18n("failed-to-update-formats"), r_1);
                        return [3, 4];
                    case 4: return [2];
                }
            });
        });
    };
    ThumbSelectorUI.prototype.calculateAspectRatioDisplayValue = function (ar) {
        if (ar <= 0)
            return "";
        var r = ar;
        var maxDenominator = 9;
        var okDiff = 0.0001;
        for (var d = 1; d <= maxDenominator; d++) {
            var n = Math.trunc(Math.round(d * r));
            var r2 = 1.0 * n / d;
            var diff = Math.abs(r - r2);
            if (diff > okDiff) {
                continue;
            }
            return n + ":" + d;
        }
        return r.toString();
    };
    ThumbSelectorUI.prototype.showThumbnailLoader = function () {
        this.$thumbnailLoaderSpinner.show();
        this.$thumbnailLoaderErrorMessage.hide();
        this.$thumbnailLoader.show();
    };
    ThumbSelectorUI.prototype.showThumbnailLoaderErrorMessage = function (message) {
        this.$thumbnailLoaderErrorMessage.text(message);
        this.$thumbnailLoaderSpinner.hide();
        this.$thumbnailLoaderErrorMessage.show();
        this.$thumbnailLoader.show();
    };
    ThumbSelectorUI.prototype.hideThumbnailLoader = function () {
        this.$thumbnailLoader.hide();
    };
    ThumbSelectorUI.prototype.updateThumbnail = function () {
        var id = this.settings.instanceConfig.id;
        this.$thumbImg.hide();
        this.$thumbImg.attr("src", "");
        if (!id)
            return;
        this.showThumbnailLoader();
        var self = this;
        var effects = self.getEffectsForTarget();
        var format = new ImageVault.ThumbnailFormat();
        format.MediaFormatOutputType = ImageVault.MediaFormatOutputType.WebSafe;
        format.Effects = effects;
        var query = {
            Filter: { Id: [id] },
            Populate: { MediaFormats: [format] },
            MediaUrlBase: self.settings.config.ivUrl + "apiv2/mediastreamservice"
        };
        var accessToken = self.settings.client.getCachedAccessToken();
        var imageQs = "?ivauthorization=" + encodeURIComponent(accessToken);
        self.getMedia(query).then(function (media) {
            self.$thumbImg.attr("src", media.Url + imageQs).attr("width", media.Width).attr("height", media.Height);
            self.$thumbImg.show();
            self.$thumbImg.on("load", function () { self.hideThumbnailLoader(); });
        }).catch(function (e) {
            self.showThumbnailLoaderErrorMessage(e);
        });
    };
    ThumbSelectorUI.prototype.editAsset = function () {
        var self = this;
        var $iframe = $("#editMedia");
        $iframe.on("load", function () {
            self.$assetEditor.show();
            self.logResult("DEBUG", "Iframe loaded: " + $iframe.attr("src"));
            $iframe.unbind("load");
            $iframe.unbind("keydown");
            var win = $iframe.get(0).contentWindow;
            self.initEditor(win);
        });
        $iframe.attr("src", self.settings.resourcePath + "imagevault-client-script/editor.html?v=4&timestamp=" + (new Date()).getTime());
    };
    ThumbSelectorUI.prototype.initEditor = function (win) {
        var self = this;
        var id = this.settings.instanceConfig.id;
        if (!id) {
            console.log("Cannot edit asset if no one is selected");
            return;
        }
        var selectedFormat = this.getSelectedFormatData();
        var keepAspectRatio = false;
        var format = new ImageVault.ThumbnailFormat();
        if (this.broker.infoPanel.isCurrentAssetVideo()) {
            format = new ImageVault.WebMediaFormat();
        }
        format.MediaFormatOutputType = ImageVault.MediaFormatOutputType.WebSafe;
        self.getMedia({
            Filter: { Id: [id] },
            Populate: {
                MediaFormats: [format]
            },
            MediaUrlBase: self.settings.config.ivUrl + "apiv2/mediastreamservice"
        }).then(function (media) {
            if (!media) {
                throw "Failed to retrieve media for asset id " + id + " and format " + JSON.stringify(format);
            }
            var effectArray = self.settings.instanceConfig.effects;
            var effects = JSON.stringify(effectArray);
            var params = {
                id: id,
                editorSettings: { width: win.innerWidth, height: win.innerHeight },
                coreSettings: {
                    client: self.settings.client,
                    mediaUrlBase: self.settings.config.ivUrl + "apiv2/mediastreamservice",
                    useMediaAuthenticationParameter: true,
                },
                languageSettings: {
                    editorWidthInputLabel: self.i18n("width"),
                    editorHeightInputLabel: self.i18n("height"),
                    editorOkButtonText: self.i18n("ok"),
                    editorCancelButtonText: self.i18n("cancel"),
                    editorWarningIconText: self.i18n("warning-image-is-scaled-to-fit-the-area"),
                    editorReloadButtonText: self.i18n("reload"),
                    editorLoadErrorText: self.i18n("editor-load-error"),
                    title: self.i18n("editor-title")
                },
                currentEffects: effects,
                originalFormat: {
                    width: media.Width,
                    height: media.Height,
                    url: media.Url,
                    contentType: media.ContentType
                },
                originalFormatContentType: media.ContentType,
                originalFormatUrl: media.Url,
                keepAspectRatio: keepAspectRatio,
                nodeInfo: null,
                targetFormat: {
                    width: (selectedFormat ? selectedFormat.width : 0),
                    height: (selectedFormat ? selectedFormat.height : 0),
                    resizeMode: (selectedFormat ? selectedFormat.resizeMode : 0)
                },
                callback: function (effects) {
                    if (effects) {
                        if (typeof (effects) === "string") {
                            effects = JSON.parse(effects);
                        }
                        self.settings.instanceConfig.effects = effects;
                        if (effects && effects.length > 0) {
                            self.logResult("INFO", effects);
                        }
                        self.updateThumbnail();
                        if (self.props.thumbEdited) {
                            self.props.thumbEdited();
                        }
                    }
                    self.$assetEditor.hide();
                }
            };
            win.ImageVault.Editor.openEditorInstance(params);
        }).catch(function (e) {
            self.error(e);
            self.$assetEditor.hide();
        });
    };
    ThumbSelectorUI.prototype.clearThumb = function () {
        this.$thumbImg.hide();
        this.$thumbImg.attr("src", "");
    };
    return ThumbSelectorUI;
}(ConfigUI_1.ConfigUI));
exports.ThumbSelectorUI = ThumbSelectorUI;


/***/ }),

/***/ "./src/ts/VersionUtil.ts":
/*!*******************************!*\
  !*** ./src/ts/VersionUtil.ts ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var VersionUtil = (function () {
    function VersionUtil() {
    }
    VersionUtil.verifyMinVersion = function (version, minVersion) {
        if (!version)
            return false;
        if (!minVersion)
            return true;
        var va = version.split(".");
        var mva = minVersion.split(".");
        for (var i = 0; i < mva.length; i++) {
            var min = parseInt(mva[i]);
            if (min === 0)
                continue;
            if (va.length <= i && min > 0)
                return false;
            var v = parseInt(va[i]);
            if (v === min)
                continue;
            return v > min;
        }
        return true;
    };
    return VersionUtil;
}());
exports.VersionUtil = VersionUtil;


/***/ }),

/***/ "./src/ts/bundles/configExports.ts":
/*!*****************************************!*\
  !*** ./src/ts/bundles/configExports.ts ***!
  \*****************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

var ns = (window.ImageVault = window.ImageVault || {});
ns.ConfigLoaderUI = __webpack_require__(/*! ../ConfigLoaderUI */ "./src/ts/ConfigLoaderUI.ts").ConfigLoaderUI;


/***/ }),

/***/ "jquery":
/*!********************!*\
  !*** external "$" ***!
  \********************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = $;

/***/ })

/******/ });
//# sourceMappingURL=config.min.js.map