import { ConfigUI } from "./ConfigUI";
import { ISettings } from "./Settings";

export class ConfigPanelUI extends ConfigUI {
    $panel: JQuery<HTMLElement>;
    constructor(settings: ISettings, id: string) {
        super(settings);
        this.$panel = $("#" + id);
    }
    init() {
    }
    setEnabled(enabled: boolean) {
        if (enabled) {
            this.$panel.show();
        } else {
            this.$panel.hide();
        }
    }

}